/*
 * See these files (usually under /usr/share/gnome-shell):
 * -- js/ui/dateMenu.js
 * -- js/ui/main.js
 * -- js/ui/dateMenu.js
 * -- js/ui/screenShield.js
 */


let calendarButtonClockFormat = "%F"
let panelClockFormat = "%F  %a  %R"
let lockScreenDateFormat = "%F"


/***********************************************/


const Lang = imports.lang;
const Mainloop = imports.mainloop;
const Panel = imports.ui.main.panel;

const LockClock = imports.ui.screenShield.Clock.prototype;
const CalendarClock = imports.ui.dateMenu.DateMenuButton.prototype;


const EvilCalendarUpdateClock = CalendarClock._updateClockAndDate
const EvilScreenShieldUpdateClock = LockClock._updateClock;

const CalendarUpdateClock = function() {
    let displayDate = new Date();
    this._clockDisplay.set_text(displayDate.toLocaleFormat(panelClockFormat));
    this._date.set_text(displayDate.toLocaleFormat(calendarButtonClockFormat));
}
const ScreenShieldUpdateClock = function() {
    this._time.text = this._wallClock.clock;
    let date = new Date();
    this._date.text = date.toLocaleFormat(lockScreenDateFormat);
}


var dm_disconnectId = null;
var lc_disconnectId = null;

function enable() {
    let dm = Panel.statusArea.dateMenu;
    //XXX Unable to disconnect by ID
    //(gnome-shell/javascript's gtk sucks)
    //dm._clock.disconnect(XXX ???);
    dm._updateClockAndDate = CalendarUpdateClock;
    var dm_disconnectId = dm._clock.connect('notify::clock',
            Lang.bind(dm, dm._updateClockAndDate));
    dm._updateClockAndDate();

    LockClock._updateClock = ScreenShieldUpdateClock;
    let lc = imports.ui.main.screenShield;
    //XXX same problem as with `dm` above.
    let has_wclock = true;
    try { lc._wallClock; } catch (e) { has_wclock = false; }
    if (has_wclock) {
        lc._updateClock = ScreenShieldUpdateClock;
        var lc_disconnectId = lc._wallClock.connect('notify::clock',
                Lang.bind(lc, lc._updateClock));
        lc._updateClock();
    }
}

function disable() {
    let dm = Panel.statusArea.dateMenu;
    dm._clock.disconnect(dm_disconnectId);
    dm._updateClockAndDate = EvilCalendarUpdateClock;
    //(XXX should connect, but we are not disconnecting above...)
    //var dm_disconnectId = dm._clock.connect('notify::clock',
    //        Lang.bind(dm, dm._updateClockAndDate));
    dm._updateClockAndDate();

    LockClock._updateClock = EvilScreenShieldUpdateClock;
    let lc = imports.ui.main.screenShield;
    let has_wclock = true;
    try { lc._wallClock; } catch (e) { has_wclock = false; }
    if (has_wclock) {
        lc._wallClock.disconnect(lc_disconnectId);
        lc._updateClock = EvilScreenShieldUpdateClock;
        //XXX same problem as with `dm` above.
        lc._updateClock();
    }
}

function init() {
}
